SystemOrganization addCategory: #'A4BP-JVM'!

Object subclass: #A4BPJVMConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-JVM'!

!A4BPJVMConfiguration class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/14/2015 21:00'!
addPath: path stream: stremPath.
	stremPath nextPutAll: path.
	stremPath nextPutAll: self psp.
! !

!A4BPJVMConfiguration class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/14/2015 21:00'!
basePathDir
	^ self sp,'Users',self sp,'peralta',self sp,'A4BP_LIB'
	

! !

!A4BPJVMConfiguration class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/14/2015 19:24'!
exampleConfig
	"self exampleConfig"
| jvmSettings |
 "You can set the path to the Java VM library by editing the path as
needed."
JNIPortJNIInterface libraryFile: self macLibPath.
"JNIPortJNIInterface libraryFile:
'C:\Programme\Java\jre7\bin\client\jvm.dll' ."

 jvmSettings := JVMSettings new.
 jvmSettings usesGhosts: true.
 jvmSettings supportsCallbacks: true.
 jvmSettings jniPortSettings  useJNIHelperLibrary: false.
jvmSettings ghostClassSettings retainMethodSource: true.

 "On Mac OS X and Linux, class path entries are separated by colons."
 "On Windows, you have to use semicolons instead. Edit the following line as
needed."
jvmSettings runtimeSettings classpath: ('.;.\JNIPort.jar;.\JNIPort-Tests.jar:' ,  self jbpmsimjavaPath).
" jvmSettings runtimeSettings classpath:
'.;.\JNIPort.jar;.\JNIPort-Tests.jar'."

 "Uncomment the following if you want the Java VM to emit verbose messages.
  How to access these messages depends on your platform.
  On Mac OS X, they are visible in the Console application."
jvmSettings runtimeSettings addOption: '-verbose:jni'; addOption:'-verbose:gc'; addOption: '-verbose:class'.
Cursor execute showWhile: [JVM newWithSettings: jvmSettings].


! !

!A4BPJVMConfiguration class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/14/2015 18:44'!
exampleConfig2
"Then the fun starts:"
| zfClass zipfile entries |
zfClass := JVM current findClass: #'java.util.zip.ZipFile'.
zipfile := zfClass new_String: 'JNIPort.jar'.
zipfile size. "--> answers an Integer"
entries := zipfile entries.
entries asAnEnumeration do: [:each | Transcript cr; print: each].! !

!A4BPJVMConfiguration class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/14/2015 20:25'!
jbpmsimjavaPath
	"'/Users/peralta/Library/Application\ Support/Pharo/images/A4BP50/jbpm.sim.jar'"
 ^ '/Users/peralta/jbpm.sim.jar'! !

!A4BPJVMConfiguration class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/14/2015 20:58'!
loadClassPath
	|stremPath files|
   stremPath := WriteStream on: (String new).
	self addPath: '.' stream: stremPath.
	files := self basePathDir asFileReference allFiles select: [ :each | each basename endsWith: '.jar' ].
	files do:[ :file |
		self addPath: file fullName stream: stremPath.	
	].
   ^ stremPath contents
! !

!A4BPJVMConfiguration class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/14/2015 19:08'!
macLibPath
	^ './System/Library/Java/JavaVirtualMachines/1.6.0.jdk/Contents/Libraries/libclient.dylib'! !

!A4BPJVMConfiguration class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/14/2015 21:01'!
psp
	^ ':'
! !

!A4BPJVMConfiguration class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/14/2015 21:01'!
sp
	^ '/'
! !

!A4BPJVMConfiguration class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/14/2015 21:00'!
startJava
	"self startJava"
	| settings  |
	JVM current ifNotNil:[^ JVM current].
	settings := JVMSettings new.
	settings usesGhosts: true.
	(settings jniPortSettings)
    	jvmClass: JVMWithCallbacks;
    	jniLibraryFilename: self macLibPath.
	settings runtimeSettings classpath: self loadClassPath. 
	settings runtimeSettings 
	addOption: '-verbose:jni'; 
	addOption:'-verbose:gc'; 
	addOption: '-verbose:class';
	addOption: '-Xdebug';
	addOption: '-Xrunjdwp:server=y,transport=dt_socket,address=4000,suspend=n'.
	JVM shutDown.
	Cursor execute showWhile: [JVM newWithSettings: settings].
	^ JVM current
 
! !

Object subclass: #A4BPJVMSimServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-JVM'!

!A4BPJVMSimServer class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/15/2015 10:30'!
getPathInfo: aModel
	| zfClass jvm ss result xml j_xml|
	jvm := JVM current.
	zfClass := jvm findClass: #'a4bp.integration.SimulationServer'.
	ss := zfClass new.
	xml := aModel text.
	j_xml := xml asJavaString: jvm.
	result := ss getPathInfo_String:xml.
	^ result asString! !

!A4BPJVMSimServer class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/15/2015 10:37'!
runSimulationId: processId bpmnModel: aModel numInstances: numInstances intervalInt: intervalInt intervalUnit: intervalUnit
	"public String runSimulation(String processId, String bpmnXML,
			int numInstances, int intervalInt, String intervalUnit)
			throws Exception {"
	| zfClass jvm ss result xml j_xml j_processId j_numInstances j_intervalInt j_intervalUnit|
	jvm := JVM current.
	zfClass := jvm findClass: #'a4bp.integration.SimulationServer'.
	ss := zfClass new.
	xml := aModel text.
	j_xml := xml asJavaString: jvm.
	j_processId := processId asJavaString: jvm.
	j_numInstances := numInstances asJavaInteger:jvm.
	j_intervalInt := intervalInt asJavaInteger:jvm.
	j_intervalUnit := intervalUnit asJavaString: jvm.
	result := ss runSimulation_String: j_processId String: j_xml int: j_numInstances int: j_intervalInt String: j_intervalUnit.
	^ result asString! !

!A4BPJVMSimServer class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/15/2015 10:40'!
runSimulationModel: aModel
	|processId numInstances intervalInt intervalUnit|
	processId := UUID new asString.
	numInstances := 1. 
	intervalInt := 1.
	intervalUnit := 'seconds'.
	^ self runSimulationId: processId bpmnModel: aModel numInstances: numInstances intervalInt: intervalInt intervalUnit: intervalUnit! !

!A4BPJVMSimServer class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/15/2015 10:39'!
runSimulationModel: aModel numInstances: numInstances intervalInt: intervalInt intervalUnit: intervalUnit
	|processId|
	processId := UUID new asString.
	^ self runSimulationId: processId bpmnModel: aModel numInstances: numInstances intervalInt: intervalInt intervalUnit: intervalUnit! !
